/*
 * This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Switzerland License. To view a copy of this license, visit
 * http://creativecommons.org/licenses/by-nc-sa/2.5/ch/ or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.
 */

package ch.njol.skript.effects;

import java.util.List;
import java.util.regex.Matcher;

import org.bukkit.event.Event;

import ch.njol.skript.Skript;
import ch.njol.skript.api.Effect;
import ch.njol.skript.api.Variable;

/**
 * @author Peter Gttinger
 * 
 */
public class EffAdd extends Effect {
	
	static {
		Skript.addEffect(EffAdd.class, "add %object% to %object%");
	}
	
	public EffAdd() {}
	
	private Variable<?> what;
	private Variable<?> to;
	
	@Override
	public void init(final List<Variable<?>> vars, final int matchedPattern, final Matcher matcher) {
		what = vars.get(0);
		to = vars.get(1);
	}
	
	@Override
	protected void execute(final Event e) {
		to.add(e, what.get(e));
	}
	
}
